
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>线程操作之生产者及消费者 / 憋错料</title>

    <meta name="description" content="线程操作之生产者及消费者 范例:Info.java 1 public class Info { 2 3 private String name=&quot;王sir&quot;; 4 private String Content=&quot;JAVA讲师&quot;; 5 public String getName() { 6 return name; 7 } 8 public void setName(String name) { 9 this.name = name; 10 } 11 public String ge ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">线程操作之生产者及消费者</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>范例：Info.java</p>
<pre> 1 public class Info {
 2
 3     private String name="王sir";
 4     private String Content="JAVA讲师";
 5     public String getName() {
 6         return name;
 7     }
 8     public void setName(String name) {
 9         this.name = name;
10     }
11     public String getContent() {
12         return Content;
13     }
14     public void setContent(String content) {
15         Content = content;
16     }
17
18 }</pre>
<p>范例：生产者</p>
<pre> 1 public class Producer implements Runnable {
 2
 3     private Info info = null;
 4
 5     public Producer(Info info) {
 6         this.info = info;
 7     }
 8     @Override
 9     public void run() {
10
11         boolean flag = false;
12         for (int i = 0; i &lt; 50; i++) {
13             if (flag) {
14                 this.info.setName("王sir");
15                 try {
16                     Thread.sleep(90);
17                 } catch (InterruptedException e) {
18                     e.printStackTrace();
19                 }
20                 this.info.setContent("JAVA講師");
21                 flag = false;
22             } else {
23                 this.info.setName("張sir");
24                 try {
25                     Thread.sleep(90);
26
27                 } catch (InterruptedException e) {
28                     e.printStackTrace();
29                 }
30                 this.info.setContent("C#講師");
31                 flag = true;
32             }
33         }
34     }
35 }</pre>
<p>范例：消费者</p>
<pre> 1 public class Consumer implements Runnable {
 2
 3     private Info info = null;
 4
 5     public Consumer(Info info) {
 6         this.info = info;
 7     }
 8
 9     @Override
10     public void run() {
11         for (int i = 0; i &lt; 50; i++) {
12             try {
13                 Thread.sleep(100);
14             } catch (InterruptedException e) {
15                 e.printStackTrace();
16             }
17             System.out.println(this.info.getName() + "--&gt;"
18                     + this.info.getContent());
19         }
20     }
21
22 }</pre>
<p>范例：主调方法</p>
<pre> 1 public class ThreadCaseDemo {
 2
 3     public static void main(String[] args) {
 4         Info i = new Info();
 5         Producer pro = new Producer(i);
 6         Consumer con = new Consumer(i);
 7         new Thread(pro).start();
 8         new Thread(con).start();
 9     }
10 }</pre>
<p>范例：运行结果</p>
<p>張sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;C#講師<br />張sir--&gt;JAVA講師<br />王sir--&gt;C#講師<br />張sir--&gt;JAVA講師<br />王sir--&gt;C#講師<br />張sir--&gt;JAVA講師<br />王sir--&gt;C#講師<br />張sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師<br />王sir--&gt;JAVA講師</p>
<p>线程的运行是由CPU调度决定的，具有不容忽视的不确定性，所以在线程的使用中，存在2点问题：</p>
<p>1.假设生产者线程刚向数据存储空间添加了信息的名称，还没有加入该信息的内容，程序就切换到了消费者线程，消费者线程将把信息的名称和上一个信息的内容联系到一起。（同步问题）</p>
<p>2.生产者放了若干次的数据，消费者才开始取数据，或者是，消费者取完一个数据后，还没等到生产者放入新的数据，有重复取出已取过的数据。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 18:45:56 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>线程操作之生产者及消费者的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ORk2K0.html" rel="bookmark">linux中的线程同步：生产者、消费者问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#include &lt;stdio.h&gt; #include &lt;semaphore.h&gt; #include &lt;unistd.h&gt; #include &lt;stdlib.h&gt; #include &lt;pthread.h&gt; #define BUFFER_COUNT 5 int Buffer[BUFFER_COUNT]; //指针数组 int front = 0; int tail = 0; sem_t SemProd; sem_t SemCon; void* pr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4JzKQ4.html" rel="bookmark">多线程操作实例&mdash;&mdash;生产者与消费者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面对多线程学习生产者与消费者是最基本的实例 对于java后端开发的人员必须要掌握,还有考研考试计算机操作系统的同鞋. 下面是三个实例对于生产者与消费者的的例子,层层递进,逐步解决问题. 问题:生产者——设置信息名字name,和内容content 消费者——负责取出设置的信息. 一.基本实现 由于线程的不确定性可能出现以下问题: (1)消费者取出的信息不匹配,即不是由同一个生产者设置的信息 (2)生产者生产了多个信息,消费者才开始取出信息,或消费者取出的重复的信息. 上面的问题下面会逐一解决,下面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/L3rQYq0.html" rel="bookmark">JAVA线程通信之生产者与消费者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package cn.test.hf.test3; import java.util.concurrent.locks.Condition;import java.util.concurrent.locks.ReentrantLock; public class FactoryUtils { private Resource resource; private int producerId = 1; // 可重入锁 ReentrantLock lock = new ReentrantLock()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wmjBjM.html" rel="bookmark">Java线程同步模型-生产者与消费者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java生产者与消费者模型是经典Java线程同步模型,涉及使用同步锁控制生产者线程和消费者线程同步运行问题.同步对象是仓库资源,生产者线程生产向仓库中生产商品,消费者线程从仓库中消费商品,当生产者线程生产的商品达到仓库的90%时,生产者线程停止生产并通知消费者线程开始消费,当消费者线程消耗到仓库的10%时,消费者线程停止消费并通知生产者线程恢复生产,如此循环往复过程. 如下图解: T1时刻分析 T2时刻 T3时刻 T4时刻 上图的分析,T3同T1时刻相同场景,T2同T2时刻相同场景,程序如此循环			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wZpkQ0.html" rel="bookmark">线程 ---- 锁（生产者、消费者）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java经典面试题 -----  生产者消费者 /** * 生产者 消费者问题 * 解释 : wait notify 方法 * sleep 与 wait的区别 * 线程锁机制 */ public class ProducerConsumer { public static void main(String[] args) { SyncStack ss = new SyncStack(); Producer p = new Producer(ss); Consumer c = new Consum			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jlANe4.html" rel="bookmark">线程通信（生产者与消费者问题）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.线程通信的必要性 多线程不仅共享资源,而且相互牵制向前运行. 2.线程通信的方法(都是在Object中定义) 3个方法: 1)    wait() 可运行转入阻塞状态,放锁 2)    notify() 阻塞转入可运行状态,获得锁 3)    notifyAll() 所有调用wait方法而被挂起的线程重新启动,有个条件:wait与notifyAll必须是属于同一个对象 必须在同步方法或同步代码块中使用 3.共享资源类(仓库) 注:共享资源(产品),牵制信息(产品有无)  package co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wDBE84.html" rel="bookmark">线程同步之生产者与消费者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public class Customer extends Thread{ private Queue q; public Customer(Queue q){ this.q = q; } public void run(){ for(int i = 0; i &lt; 10; i++){ int value = q.get(); } }}public class Producer extends Thread{ private Queue q; public Producer(Queue q){ t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jlGVE4.html" rel="bookmark">Java经典线程同步问题------生产者与消费者</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先上代码 class Test { public static void main(String []args) { Queue q=new Queue(); Producer p=new Producer(q); Consumer c=new Consumer(q); p.start(); c.start(); } } class Producer extends Thread { Queue q; Producer(Queue q) { this.q=q; } public void run			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgN99B4.html" rel="bookmark">基于线程实现的生产者消费者模型&lpar;Object&period;wait&lpar;&rpar;&comma;Object&period;notify&lpar;&rpar;方法&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				需求背景 利用线程来模拟生产者和消费者模型 系统建模 这个系统涉及到三个角色,生产者,消费者,任务队列,三个角色之间的关系非常简单,生产者和消费者拥有一个任务队列的引用,生产者负责往队列中放置对象(id),消费者负责从队列中获取对象(id),其关联关系如下 方案1 因为是多线程操作,所以对任务的存取都要使用线程同步加锁机制,看一下我们的TaskQueue类,两个主方法都加了synchronized修饰,这就意味着,一个时间点只可能有一个线程对这个方法进行操作 TaskQueue类代码 [java			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QZ0YO4O.html" rel="bookmark" class="title">action</a>
					<div>
						package com.ivchat.park.coupons.action; import java.text.SimpleDateFormat;import java.util.ArrayList ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n4A58g4.html" rel="bookmark" class="title">配置本地yum源</a>
					<div>
						在我们使用Linux的过程中会涉及到安装小程序,然而一般来说用rpm安装的话,最麻烦的一个问题就是涉及到程序的依赖,你得安装了一个又一个的依赖程序才能让你想要安装的程序跑起来(忽略依赖安装了用着也有问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49ZdXbM.html" rel="bookmark" class="title">bzoj1864 三色二叉树</a>
					<div>
						Description Input 仅有一行,不超过500000个字符,表示一个二叉树序列. Output 输出文件也只有一行,包含两个数,依次表示最多和最少有多少个点能够被染成绿色. 记录每个节点染 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyV9j4.html" rel="bookmark" class="title">PHP面相对象：声明类和实例化类</a>
					<div>
						一.类的声明 1 //使用class关键词+类名+{}声明一个类 2 class Demo { //类名首字母需要大写,命名遵守驼峰命名法 3 var $name; //[修饰词] 变量名 4 5 f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvXEb0.html" rel="bookmark" class="title">美化xterm</a>
					<div>
						很多软件调试时,会打开xterm,不过很难看,字体.背景等等都不好看,网上找到了一个不错的xterm的配置文件 !look and feel xterm.termName: xterm-256colo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nv12N0.html" rel="bookmark" class="title">&lbrack;Linux&rsqb; PuTTY指令汇总&lpar;持续更新中&period;&period;&period;&rpar;</a>
					<div>
						写在前面: 以前真心没有玩过Linux系统,总感觉整天摆弄Linux的同学都是大牛.如今,在公司里实习需要远程登录Linux服务器,所有的代码都要在开发板上完成,所以被逼无奈也不得不定下心来好好学学L ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvWgo0.html" rel="bookmark" class="title">github环境搭建</a>
					<div>
						1.安装github github官网下载安装包,window环境下载地址:https://desktop.github.com/ 下载之后双击安装即可 2.安装Gradle 下载地址:http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Momg5b3.html" rel="bookmark" class="title">Linux及安全实验三：ShellShock 攻击实验</a>
					<div>
						ShellShock 攻击实验 20125107聂航 一. 实验描述 2014年9月24日,Bash中发现了一个严重漏洞shellshock,该漏洞可用于许多系统,并且既可以远程也可以在本地触发.在本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrojn4.html" rel="bookmark" class="title">使用XmlWriter写Xml</a>
					<div>
						使用XmlWriter写Xml 假定创建了XmlWriter的实例变量xmlWriter,下文中将使用此实例变量写Xml 1.如何使用XmlWriter写Xml文档声明 ? // WriteStart ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0leXYX3.html" rel="bookmark" class="title">分页加载</a>
					<div>
						现在分页加载在apk中应用广泛 那么是怎么实现的呢 下面让我们举一个小例子来看一下 首先是我们的自定义的listview 在布局中引用 那么就看一下我们的布局文件 &lt;LinearLayout x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVaBb4.html" rel="bookmark" class="title">iOS版本更新与集成百度地图</a>
					<div>
						App在AppStore上会对应一个地址, 通过这个地址可以获得这个App的版本号, 与当前App的版本号做对比, 如果小于当前的版本号, 进行版本更新. 不论我们需要集成什么的SDK, 都先要获取一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9dkE0.html" rel="bookmark" class="title">初学html后，写的周杰伦的介绍页面</a>
					<div>
						1 &lt;!DOCTYPE html&gt; 2 &lt;html&gt; 3 &lt;head&gt; 4 &lt;title&gt;&lt;/title&gt; 5 &lt;meta chars ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVQZox4.html" rel="bookmark" class="title">使用rosed编辑ROS文件</a>
					<div>
						1.1使用rosed. rosed是rosbash套件的一部分．它可以使你通过package的名字直接编辑一个package中的文件而不用输入package的整个路径． 用法: $ rosed [pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41ewGg4.html" rel="bookmark" class="title">【palindrome partitioning II】cpp</a>
					<div>
						题目: Given a string s, partition s such that every substring of the partition is a palindrome. Return ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47zEdy3.html" rel="bookmark" class="title">IOS Dictionary和Model相互转换</a>
					<div>
						// // HYBJSONModel.h // Json2ModelDemo // // Created by huangyibiao on 14-9-15. // Copyright (c) 201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j9QEZM.html" rel="bookmark" class="title">BZOJ 3878 【AHOI2014】 奇怪的计算器</a>
					<div>
						题目链接:奇怪的计算器 如果没有溢出的话,所有的标记都可以在线段树上直接维护,所以一棵线段树就解决问题了. 现在有了溢出,怎么办呢? 发现就算溢出了,各个元素的相对大小关系也是不变的.所以,如果一开始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDqvqY0.html" rel="bookmark" class="title">MySQL多实例介绍与配置</a>
					<div>
						MySQL多实例: 就是在一台机器上开户多个不同的服务端口(如:3306,3307),运行多个 MySQL服务进程,这些服务进程通过不同的socket监听不同的服务端口来 提供各自的服务. MySQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xDdB70.html" rel="bookmark" class="title">天下数据教你如何实现一个空间放多个网站</a>
					<div>
						通常一些个人站长或者公司可能同时拥有几个网站.由于其他几个网站流量不高,而每个网站都租用一个虚拟主机空间的话,感觉有点浪费.所以,大家可能会想虚拟主机能不能也像独立服务器那样放置多个网站呢?答案是肯定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xDOpL0.html" rel="bookmark" class="title">Spring MVC 数据验证&mdash;&mdash;validate注解方式</a>
					<div>
						1.说明 学习注解方式之前,应该先学习一下编码方式的spring注入.这样便于理解验证框架的工作原理.在出错的时候,也能更好的解决问题.所以本次博客教程也是基于编码方式,只是在原来的基础加上注解方式. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lLo5X0.html" rel="bookmark" class="title">WinForm中DateTimePicker显示日期和时间</a>
					<div>
						默认下dateTimePicker只显示日期, 如果只显示时间可以修改控件的Format属性为Time.如果你想现实日期+时间,就要使用自定义格式,添加代码如下: dateTimePicker1.Cu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
